﻿/*
 * Copyright (c) 2012 Kota Tsuyuzaki 
*/
jQuery.fn.reverse = Array.prototype.reverse;
String.prototype.linkify = function(){
    return this.replace(/[A-Za-z]+:\/\/[A-Za-z0-9-_]+\.[A-Za-z0-9-_:%&\?\/.=]+/g,function(m){
        return m.link(m);
      }
    );
};
String.prototype.linkuser = function(){
    return this.replace(/[@]+[A-Za-z0-9-_]+/g,function(u){
        var username = u.replace("@","")
        return u.link("http://twitter.com/"+username);
      }
    );
};
String.prototype.linktag = function(){
    return this.replace(/[#]+[A-Za-z0-9-_]+/,function(t){
        var tag = t.replace("#","%23")
        return t.link("http://search.twitter.com/search?q="+tag);
      }
    );
};


var sort_by = function(field, primer){
   return function(a,b){
       a = a[field];
       b = b[field];
       if (typeof(primer) != 'undefined'){
           a = primer(a);
           b = primer(b);
       }
       if (a<b) return -1;
       if (a>b) return 1;
       return 0;
   }
}

var make_url = function(elem){

    user = elem.attr('user');
    album = elem.attr('album');
    authkey = elem.attr('authkey')

    if(album != window.picasatter['text-'+album]){
        window.picasatter['last_id'+album] = 0;
        window.picasatter['text-'+album] = album;
        window.picasatter['count-'+album] = 12;;
    }
    if(window.picasatter['count-'+album] > 10){
        //elem.prepend('<div class="tweet"><img src="http://picasatter.com/widget/favicon.gif" align="absmiddle" />real time twitter by: <a href="http://picasatter.com" target="_blank">picasatter.com</a></div>');
        window.picasatter['count-'+album] = 0;
    }

    // Picasa Web Album API: https://picasaweb.google.com/data/feed/api/user/
    var url = "https://picasaweb.google.com/data/feed/api/user/"+user+"/albumid/"+album+'?';
    if(authkey){
        url += "alt=json&limit="+window.picasatter['count-'+album]+"&authkey="+authkey+"&callback=?";
    }else{
        url += "alt=json&limit="+window.picasatter['count-'+album]+"&callback=?";
    }
    return url; 
}

function countDown(endDateTime) {
    var startDateTime = new Date();
    if(endDateTime<startDateTime){
        toggle($('.render'), 'feed_check', "<div class=\"start\"></div>", "<div class=\"stop\"></div>");
        window.picasatter['timeleft'] = false;
        $('#TimeLeft').html(window.picasatter['timelimit']);
    }
    if(window.picasatter['timeleft']==false) return false;
    var d = Math.floor((endDateTime-startDateTime)/(24*60*60*1000))
    var h = Math.floor(((endDateTime-startDateTime)%(24*60*60*1000))/(60*60*1000))
    var m = Math.floor(((endDateTime-startDateTime)%(24*60*60*1000))/(60*1000))%60
    var s = Math.floor(((endDateTime-startDateTime)%(24*60*60*1000))/1000)%60%60
    if(s<10) s = "0" + s;
    $("#TimeLeft").text(m+':'+s);
    setTimeout(function(){countDown(endDateTime);}, 500);
}

function fetch_main_window(id, src, team, summary, stale){

    window.picasatter['team'] = team;
    if(stale)$('#tw'+id+'new').html("");
    $("#main_window").fadeOut(200, function(){
        if($(this).attr('id')=='main_window')$(this).attr("src", src);
        else $(this).attr("src", "./images/" + team + ".png");
        $(this).fadeIn(200);
      }
    );
    if(summary){
        $("#title").fadeOut(200, function(){
            if(summary)$(this).html(summary);
            else $(this).html("photo_title");
            $(this).fadeIn(200);
          }
        );
    }
    hideOX(200);
}


function slide_show(elem){
    elem = $(elem);
    var url = make_url(elem);
    if(window.picasatter['feed_check']==false){
        setTimeout(function(){slide_show(elem)}, window.picasatter['timeout']);
        return false;
    }
    $.getJSON(url,function(json){

	length = $(json.feed.entry).length;
	num = ~~(Math.random() * length);
	entry = $(json.feed.entry)[num];
        fetch_main_window(entry.content.src)
        setTimeout(function(){slide_show(elem)}, window.picasatter['timeout']);
      }
    );
    return false;
}
function toggle(elem, checker, tmsg, fmsg){
    if(window.picasatter[checker]){
        window.picasatter[checker] = false;
        $(elem).html(fmsg);
    }else{
        window.picasatter[checker] = true;
        $(elem).html(tmsg);
    }
    return false;
}

function increment(team){
    var now = $('#dcount' + team).html();
    if(isNaN(now))return false;
    now++;
    $('#dcount' + team).html(""+now);
}

function decrement(team){
    var now = $('#dcount' + team).html();
    if(isNaN(now))return false;
    now--;
    $('#dcount' + team).html(""+now);
}

function highlight_hide(elem, num){
    elem = $(elem);
    var check = elem.attr('class')=='toolcircle'? true : false;
    if(check){
        $('.toolcross').fadeOut();
    }else{
        $('.toolcircle').fadeOut();
    }
    elem.css({"background-color":"#EE6"});
    setTimeout(function(){
        for(i=0; i < num-1; i++){
            elem.fadeOut('slow').fadeIn('fast');
        }
        elem.fadeOut('slow').fadeIn('fast', function(){
            setTimeout(function(){ hideOX('slow');}, 1000);
            if(check) setTimeout(function(){ increment(window.picasatter['team'])}, 1000);
          }
        );
       },1000
    );
    return false;
}


function popOX(speed){
    $('.toolcircle, .toolcross').fadeIn(speed);
    return false;
}

function hideOX(speed){
    $('.toolcircle, .toolcross').fadeOut(speed,function(){
        $(this).css({"background-color":"#EEE"});
    });
    return false;
}


function scroll(elem, event, delta){
    elem = $(elem);
    if(delta > 0){
        if(window.picasatter['showarray'].length==0) return false;
        id = window.picasatter['showarray'].pop();
        $('#tw'+id).fadeOut('fast').slideUp('fast');
        window.picasatter['hidearray'].push(id);
    }else if(delta < 0){
        if(window.picasatter['hidearray'].length==0) return false;
        id = window.picasatter['hidearray'].pop();
        $('#tw'+id).fadeIn('fast').slideDown('fast');
        window.picasatter['showarray'].push(id);
    }
    return false;
}

function table_bind(elem, prefix, rows, columns, fn){
    elem = $(elem);
    for(i = 0; i < rows.length; i++){
        for(j = 0; j < columns.length; j++){
            cid = prefix + rows[i] + columns[j];
            //window.picasatter[cid]=false;
            $('#'+cid).bind("click", columns[j], function(e){fn(e.data);});
        }
    }
}

function blink(elem, interval){
    elem = $(elem);
    fadetime = parseInt(interval/2);
    elem.fadeOut(fadetime).fadeIn(fadetime);
    setTimeout(function(){blink(elem,interval)}, 1800);
    //elem.fadeOut(fadetime).fadeIn(fadetime, setTimeout(function(){blink($(this),interval)}, 0));
}

function draw_table(elem, rows, columns, value, fn){
    elem = $(elem);
    //create header columns
    var head = '<thead><tr>';
    //columns.unshift("#");
    for(i = 0; i < columns.length; i++){
        //column = '<th id="h' + columns[i] + '">' + columns[i] + '</th>';
        column = '<th id="h' + columns[i] + '"><div class="icon"><img class="' + columns[i]
                 + '" src="./images/' + columns[i] + '.png"></div></th>';
        head += column; 
    }
    head += '</tr></thead><tbody>'
    elem.append(head);

    //create each rows
    for(i = 0; i < rows.length; i++){
        var row = '<tr>';
        for(j = 0; j < columns.length; j++){
            row += '<td id="d' + rows[i] + columns[j] + '">' + value + '</td>';
        }
        row += '</tr>';
        elem.append(row);
    }

    if(fn){
        rows.unshift(""); // for header row;
        table_bind(elem, 'h', rows, columns, increment);  //header
        table_bind(elem, 'd', rows, columns, decrement);  //body
    }
    elem.append('</tbody>');
    //icon = (parseInt($('.main').css("width")) - 200) / columns.length ;
    //$('.icon').css("width", icon + "px"); 
    //$('.icon').css("height", icon + "px"); 
    return false;
}

function fetch_photos(elem){
    
    // initialize div element
    elem = $(elem);
    if(window.picasatter['feed_check']==false){
        setTimeout(function(){fetch_photos(elem)}, window.picasatter['timeout']);
        return false;
    }

    if(id = window.picasatter['fetch_queue'].shift()){
        tmp = $('#tw' + id + ' img');
        fetch_main_window(id, tmp.attr('src'), tmp.attr('team'), false, false);
    }
    var url = make_url(elem);
    $.getJSON(url,function(json){
        $('div.tweet:gt('+window.picasatter['limit']+')',elem).each(function(){$(this).fadeOut('slow')});
        $(json.feed.entry).each(function(){
            //feed.entry[{content:{src:hoge}}]
            var id = this.gphoto$id.$t;
            if($('#tw'+id, elem).length==0){
                window.picasatter['cotunt-'+album]++;
                //var thedate=new Date(Date.parse(this.created_at));
	        var thedate = new Date();
	        var thedatestr = thedate.getHours()+':'+thedate.getMinutes();
                var src = this.content.src;
                var summary = this.summary.$t;
                // tnum is number of team defined by using summary.
                var tnum = parseInt(summary);
                if(isNaN(tnum))tnum = 10;
                tnum--; // modify for array's index
                // team is string defined by class and tnum.
                var team = window.picasatter['class'][tnum];
                var divstr = '<div id="tw'+id+'" class="thumbnail" ><img class="' + 
                             team + '" src="'+ src + 
                             '" ><div id="tw'+id+'new" class="new">new</div></div>';
                             //this.content.src+'" ><p class="text">hogehoge<br />&nbsp;<b><a href="google.com"'+
                             //'target="_blank">user</a></b> &nbsp;-&nbsp;<b>'+thedatestr+'</b></p></div>';
                window.picasatter['last_id'+album] = id;

                if(window.picasatter['hidearray'].length==0){
                    window.picasatter['showarray'].push(id);
                }else{
                   window.picasatter['hidearray'].unshift(id);
                }

                elem.prepend(divstr);
                $('#tw'+id+' img', elem).attr('team', team);
                $('#tw'+id, elem).hide();
                $('#tw'+id, elem).bind("click", function(){fetch_main_window(id, src, team, false, true);});
                $('#tw'+id+' img',elem).hide();
                $('#tw'+id+' img',elem).fadeIn(2000);
                blink($('#tw'+id+'new',elem),1000);
                $('#tw'+id, elem).fadeIn('slow');
                window.picasatter['fetch_queue'].push(id);
            }
          }
        );
        album = escape(album);
        rrp = 100;
        setTimeout(function(){fetch_photos(elem)}, window.picasatter['timeout']);
      }
    );
    return(false);
}

$(document).ready(function(){
    window.picasatter = {'feed_check':false};
    window.picasatter['timeleft'] = false;
    window.picasatter['showarray'] = [];
    window.picasatter['hidearray'] = [];
    window.picasatter['fetch_queue'] = [];
    window.picasatter['timelimit'] = "2:00";
    titlearray = ["a person like the pooh", "Gods", "Potate", "Peace", "Fighter"];
    $(document).bind("mousewheel", function(event, delta){
        scroll($(this), event, delta);
        return false;
      }
    );
    $('.picasatter').each(function(e){
        rrp = 6;
        fetch_photos(this);
      }
    );
    $('.table').each(function(e){
        rows = $(this).attr('rows');
        rows = rows.split(',');
        columns = $(this).attr('columns');
        columns = columns.split(',');
        value = $(this).attr('value');
        value = parseInt(value);
        if(isNaN(value)) value = " ";
        window.picasatter['class'] = columns;
        draw_table($(this), rows, columns, value, true);
      }
    );
    $('.photo').each(function(e){
        rrp = 6;
        elem = $(this);
        window.picasatter['timeout'] = (timeout=elem.attr('timeout'))? timeout : 500 ;
        $(this).bind("mousewheel", function(event, delta){
            scroll($(this), event, delta);
            return false;
          }
        );
        $(this).bind("click", function(){
            popOX('slow');
            return false;
          }
        );
        if(elem.attr('f')=='slideshow'){
            //slide_show($('.picasatter')[0]);
        }
      }
    );
    $('.summary').each(function(e){
        $(this).bind("click", function(){
            title = titlearray.shift();
            $(this).fadeOut(function(){$(this).text(title).fadeIn();});
            titlearray.push(title);
            return false;
          }
        ); 
      }
    );
    $('.render').each(function(e){
        $(this).bind("click", function(){
            toggle($(this), 'feed_check', "<div class=\"start\"></div>", "<div class=\"stop\"></div>");
            date = new Date();
            date.setTime(date.getTime() + 120000);
            if(!window.picasatter['timeleft']){
                window.picasatter['timeleft'] = true;
                countDown(date);
            }else{
                window.picasatter['timeleft'] = false;
                $('#TimeLeft').text(window.picasatter['timelimit']);
            }
          }
        );
      }
    );
    $('.toolcircle,.toolcross').bind('click', function(){
        highlight_hide($(this), 3);
      }
    );
  }
);

